=== debian/changelog ===
dynarmic (6.7.0+ds-4build1) resolute; urgency=medium

  * Rebuild against llvm 21

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sat, 25 Oct 2025 05:01:00 -0400

dynarmic (6.7.0+ds-4) unstable; urgency=medium

  * d/patches: also install .inc files.
    They are included by public headers
  * d/control: use my @debian.org email

 -- Andrea Pappacoda <tachi@debian.org>  Tue, 25 Feb 2025 00:23:04 +0100

dynarmic (6.7.0+ds-3) unstable; urgency=medium

  * d/rules: also install mcl.
    These headers are publicly used by Dynarmic, and Dynarmic only. They
    are also required to compile yuzu on arm64.

 -- Andrea Pappacoda <tachi@debian.org>  Wed, 19 Feb 2025 18:00:14 +0100

dynarmic (6.7.0+ds-2) unstable; urgency=low

  * Upload to unstable
  * First dgit upload
  * d/rules: drop DYNARMIC_TESTS logic
  * d/control: apply X-Style: black
  * d/control: declare dpkg-build-api = 1

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 14 Jan 2025 16:12:24 +0100

dynarmic (6.7.0+ds-1) experimental; urgency=medium

  * New upstream version 6.7.0+ds
  * d/control: libdynarmic6.5 -> libdynarmic6.7
  * d/s/lintian-overrides: override pkg-config => pkgconf
  * d/watch: switch to last known archived version

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 10 Mar 2024 12:54:15 +0100

dynarmic (6.5.0+ds-1.1) unstable; urgency=medium

  * Non-maintainer upload
  * Drop catch2 patch (Closes: #1054803)

 -- Bastian Germann <bage@debian.org>  Sat, 04 Nov 2023 14:08:28 +0100
