=== debian/control ===
Source: dynarmic
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <tachi@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dpkg-build-api (= 1),
 catch2,
 cmake (>= 3.12),
 libboost-dev,
 libfmt-dev,
 libxbyak-dev [any-amd64],
 libzydis-dev (>= 4.0.0) [any-amd64],
 llvm-dev,
 pkg-config,
 robin-map-dev,
 zlib1g-dev | libz-dev,
Standards-Version: 4.7.0
Homepage: https://github.com/merryhime/dynarmic
Vcs-Git: https://salsa.debian.org/debian/dynarmic.git
Vcs-Browser: https://salsa.debian.org/debian/dynarmic
Description: ARM dynamic recompiler
 Dynarmic is a dynamic recompiler for the ARMv6K, ARMv7A architecture, with
 partial ARMv8 support.
 .
 In the pursuit of speed, some behavior not commonly depended upon is elided.
 Therefore this emulator does not match spec.
X-Style: black

Package: libdynarmic6.7
Architecture: any-amd64 any-arm64
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package contains the shared library.

Package: libdynarmic-dev
Section: libdevel
Architecture: any-amd64 any-arm64
Depends:
 libboost-dev,
 libdynarmic6.7 (= ${binary:Version}),
 llvm-dev,
 ${misc:Depends},
Description: ${source:Synopsis} - development
 ${source:Extended-Description}
 .
 This package contains the development files.
